<script setup lang="ts">
import { ref, nextTick, provide, onMounted } from 'vue'

import { type Product } from '@/types/Product'

import ProductList from '@/components/POScomponents/ProductList.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import CashCard from './CashCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'

import { useReceipetStore } from '@/stores/receipt'
import { usePosStore } from '@/stores/pos'

const receiptStore = useReceipetStore()
const posStore = usePosStore()

provide('receiptDialog', posStore.dialog)

const tab = ref(1)
const selected = (p: Product) => {
  receiptStore.addReceiptItem(p)
  nextTick(() => {
    if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
  })
}

const divReceiptItems = ref<HTMLElement | null>(null)

onMounted(async () => {
  await posStore.getProducts()
})
</script>

<template>
  <div style="background-color: #494949; min-height: 80vh;" class="scroll">
      <v-row>
        <v-col cols="12" md="8"
          ><v-sheet min-width="300" max-width="1300" height="831" color="#212121">
            <v-tabs v-model="tab" color="primary" align-tabs="center">
              <v-tab :value="1"><v-icon>mdi-coffee</v-icon>Hot Drinks</v-tab>
              <v-tab :value="2"><v-icon>mdi-cup</v-icon>Iced Drinks</v-tab>
              <v-tab :value="3"><v-icon>mdi-delete-variant</v-icon>Frappé</v-tab>
              <v-tab :value="4"><v-icon>mdi-baguette</v-icon>Bakery</v-tab>
            </v-tabs>
            <v-window v-model="tab">
              <v-window-item :value="1" style="margin-left: 25px">
                <ProductList :products="posStore.products1" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="2" style="margin-left: 25px">
                <ProductList :products="posStore.products2" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="3" style="margin-left: 25px">
                <ProductList :products="posStore.products3" @selected-product="selected"></ProductList>
              </v-window-item>
              <v-window-item :value="4" style="margin-left: 25px">
                <ProductList :products="posStore.products4" @selected-product="selected"></ProductList>
              </v-window-item>
            </v-window>
          </v-sheet>
        </v-col>

        <v-col cols="12" md="4">
            <v-sheet min-width="300" max-width="577" height="800">
            <v-row style="margin-top: 15px;">
              <v-col cols="12" class="pa-0">
                <div ref="divReceiptItems" style="height: 350; overflow: auto">
                  <v-sheet
                    min-width="300"
                    max-width="700"
                    height="352"
                    style="background-color: #98958c"
                  >
                    <ReceiptDetailTable></ReceiptDetailTable>
                  </v-sheet>
                </div>
              </v-col>
              <v-col cols="12" class="pa-0">
                <v-sheet min-width="300" max-width="700" height="145" color="#c5c1b7" class="center">
                    <MemberCard></MemberCard>
                </v-sheet>
              </v-col>
              <v-col cols="12" class="pa-0">
                <v-sheet min-width="300" max-width="700" height="124" color="#c5c1b7">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </v-col>
              <v-col cols="12" class="pa-0">
                <v-sheet min-width="300" max-width="700" height="94" color="#c5c1b7" class="center">
                  <CashCard></CashCard>
                </v-sheet>
              </v-col>
              <v-col cols="12" class="pa-0">
                <v-sheet min-width="300" max-width="700" height="90" color="#494949" class="center">
                  <v-container>
                    <v-row>
                      <v-col
                        ><v-btn
                          block
                          rounded="xl"
                          color="primary"
                          size="large"
                          @click="posStore.showReceipt()"
                          >Purchase</v-btn
                        ></v-col
                      >
                      <v-col
                        ><v-btn
                          block
                          rounded="xl"
                          size="large"
                          @click="posStore.showDelete()"
                          color="grey-darken-4"
                          >Cancel</v-btn
                        ></v-col
                      >
                    </v-row>
                  </v-container>
                </v-sheet>
              </v-col>
            </v-row>
          </v-sheet>
        </v-col>
      </v-row>
    </div>
      <!-- dialogDelete -->
      <v-dialog v-model="posStore.dialogDelete" max-width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
          <v-card-title align="center" class="text-h10">
            This action cannot be cancel<br />
            all values.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="posStore.deleteConfirmed()"
              >
                Yes
              </v-btn>
            </div>
          </div>
          <div align="center">
            <div
              style="
                margin: 0 auto;
                max-width: 400px;
                border: 1px solid #dfe1e6;
                border-radius: 5px;
                margin-top: 10px;
              "
            >
              <v-btn block color="primary" variant="text" @click="posStore.deleteCancelled()"> No </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>

      <!-- dialogCashNotEnough -->
      <v-dialog v-model="posStore.dialogCashNotEnough" max-width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h10">
            Cash Not
            Enough.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="posStore.closeDialog()"
              >
                Ok
              </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>
      <!-- dialogNoitem -->
      <v-dialog v-model="posStore.dialogNoitem" max-width="500px">
        <v-card>
          <br />
          <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
          <v-spacer></v-spacer>
          <v-card-title align="center" class="text-h10">
            Please Select Some
            Menu.
          </v-card-title>
          <v-spacer></v-spacer>
          <div align="center">
            <div style="margin: 0 auto; max-width: 400px">
              <v-btn
                block
                style="background-color: #e11d48"
                color="white"
                variant="text"
                @click="posStore.closeDialog()"
              >
                Ok
              </v-btn>
            </div>
          </div>
          <v-spacer></v-spacer>
          <br />
        </v-card>
      </v-dialog>
  <ReceiptDialog></ReceiptDialog>
</template>
<style scoped>
.scroll {
    overflow: hidden;
    height: 100%;
  }
.center {
  display: flex; justify-content: center; align-items: center;
}
</style>